import React, { Component } from 'react';
import logo from './logo.svg';
import './App.css';
import 'mqtt';
import {
  BrowserRouter as Router,
  Route,
  Link
} from 'react-router-dom'

var mqtt = require('mqtt');
var client;
var val;
var arrondi;
var arr = [];

const Accueil = () => (
  <article>
    <h2>Accueil</h2>
  </article>
)

const Menu = (props) => (

		<div className="menu" id = "menu">
			{props.capteurs}
		</div>

)

const Capteur = (props) => (
val = props.info[props.path[1]],
	<article>
		{props.path[1] === undefined || val === undefined ? '' : <h2>{val.name}</h2>}
		{props.path[1] === undefined || val === undefined ? '' :
			<div className="parametre">

				<h3>
        {props.info[props.path[1]].type === 'TEMPERATURE' ?
              Math.round(val.value*100)/100 : val.type === 'PERCENT' ?
              Math.round(val.value*10000)/100 : val.value}  {val.type === 'TEMPERATURE' ? '°C'  : val.type === 'PERCENT' ? '%': ''}</h3>
			</div>

		}
		{props.path[1] === undefined || props.info[props.path[1]] === undefined ? '' :
			<div className="history">
				<div>Historique :</div>
				<div className="h">
          {val.history[0] != null && val.type === 'TEMPERATURE' ?
                Math.round(val.history[0]*100)/100 : val.history[0] != null && val.type === 'PERCENT' ?
                Math.round(val.history[0]*10000)/100 : val.history[0]}
          {val.history[0] != null && val.type === 'TEMPERATURE' ? '°C'  : val.history[0] != null &&val.type === 'PERCENT' ? '%': ''}
        </div>
        <div className="h">
          {val.history[1] != null && val.type === 'TEMPERATURE' ?
                Math.round(val.history[1]*100)/100 : val.history[1] != null && val.type === 'PERCENT' ?
                Math.round(val.history[1]*10000)/100 : val.history[1]}
          {val.history[1] != null && val.type === 'TEMPERATURE' ? '°C'  : val.history[1] != null &&val.type === 'PERCENT' ? '%': ''}
        </div>
        <div className="h">
          {val.history[2] != null && val.type === 'TEMPERATURE' ?
                Math.round(val.history[2]*100)/100 : val.history[2] != null && val.type === 'PERCENT' ?
                Math.round(val.history[2]*10000)/100 : val.history[2]}
          {val.history[2] != null && val.type === 'TEMPERATURE' ? '°C'  : val.history[2] != null &&val.type === 'PERCENT' ? '%': ''}
        </div>
        <div className="h">
          {val.history[3] != null && val.type === 'TEMPERATURE' ?
                Math.round(val.history[3]*100)/100 : val.history[3] != null && val.type === 'PERCENT' ?
                Math.round(val.history[3]*10000)/100 : val.history[3]}
          {val.history[3] != null && val.type === 'TEMPERATURE' ? '°C'  : val.history[3] != null &&val.type === 'PERCENT' ? '%': ''}
        </div>
			</div>
		}

	</article>
)

class App extends Component {

  constructor(props) {
    super(props);
    this.state = {
      capteurs: []
    };
    this.connexion=this.connexion.bind(this);
    console.log(this.props);
  }

  connexion(event){
    event.preventDefault();
    event.stopPropagation();
    const that = this;
    client = mqtt.connect(document.getElementById("adress").value);
    console.log(document.getElementById("adress").value);
    client.on('connect', function () {
      client.subscribe('#');
    });
    const messages = document.querySelector('#messages');
    client.on('message', function (topic, message) {

			//Nom capteur
			var val = topic.search('/');
			var name = topic.substring(val+1);

			//Valeur/type capteur
			var json = JSON.parse(message);
			var etat = json.value;
			var type = json.type;

			var i; var pos = -1;
			//Capteur actuel
			for(i = 0; i < arr.length; i++)  {
				if(arr[i].name === name) {
					pos = i;
				}
			}

			//Ajout capteur
			if(pos === -1){

				var capteur;

				//Convertions de la valeur du capteur en nombre (quand c'est possible)
				if(isNaN(Number(etat))) {
					capteur = new Sensor(name, etat, type);
				}
				else {
					capteur = new Sensor(name, Number(etat), type);
				}


				capteur.id = arr.length;
				arr.push(capteur);

			}
			//Si on met à jour un ancien capteur
			else {

				//Mise à jour de la valeur du capteur
				arr[pos].value = etat;

			}

			that.setState({capteurs: arr});
		});


	}
  render(props) {
		const capts = this.state.capteurs.map((s) =>  <li><Link to={'/'+s.id+'/'+s.name}>{s.name}</Link></li>);

		const infoCapts = this.state.capteurs;
    return (
      <div className="App">
        <header className="App-header">
		      <div className="App-head">
		        <img src={logo} className="App-logo" alt="logo" />
		        <h1 className="App-title">ReacTP</h1>
		      </div>
		      <div className="App-server">
            <h3>
		          <form onSubmit={this.connexion}>
                <label>
				          Serveur:
                </label>
                <input id="adress" type="text" name="adresse" defaultValue="mqtt://127.0.0.1:1234"/>
                <input type="submit" value="Connexion" />
              </form>
		        </h3>
		      </div>
        </header>
      	<Router>
          <div className="Page">
      	    <nav>
      	      <ul>
      		      <li><Link to="/">Accueil</Link></li>
                {capts}
      	      </ul>
            </nav>

    	      <Route exact path="/" component={Accueil}/>
            <Route path={`/:id/:name`} component={(path) => <Capteur info={infoCapts} path={path.location.pathname}/>}/>
    	    </div>
      	</Router>
      </div>
    );
  }
}
export default App
